#!/bin/sh 
VERSION="0.9.1"
NAME="mountiso"
FULLNAME="Mount-ISO"
SUDO="sudo"
SU="kdesu"
DE="kde"

SYSTEM="`kde-config --prefix 2>/dev/null`"
LOCAL="`kde-config --localprefix 2>/dev/null`"
DESKTOP="`kde-config --userpath desktop 2>/dev/null`"

MENU_HEAD='X-KDE-Submenu=Manage ISO
X-KDE-Submenu[br]=Gest� da ISO
X-KDE-Submenu[cs]=ÃÂÃÂ­dit ISO
X-KDE-Submenu[da]=ISO hУЅndtering
X-KDE-Submenu[de]=ISO-Filemanagement
X-KDE-Submenu[es]=Gestion de ISO
X-KDE-Submenu[fr]=Gestion des ISO
X-KDE-Submenu[hu]=ISO kezelÃÂÃÂ©s
X-KDE-Submenu[it]=Gestione ISO
X-KDE-Submenu[pl]=Zarzdzanie obrazem ISO
X-KDE-Submenu[pt_BR]=Gest� da ISO
X-KDE-Submenu[ru]=ISO образ
X-KDE-Submenu[sk]=RiadiÃÂ¥ ISO'

MENU_MOUNT='[Desktop Action MountISOImage]
Icon=cdimage
Name=Mount Image
Name[br]=Montar a imagem
Name[cs]=PÃÂipojit obraz
Name[da]=MontУЉr CD-billede
Name[de]=ISO-File einbinden
Name[es]=Montar imagen
Name[fr]=Monter l`image
Name[hu]=LemezkÃÂÃÂ©p felcsatolÃÂÃÂ¡sa
Name[it]=Monta immagine
Name[pl]=Zamontuj obraz
Name[pt_BR]=Montar a imagem
Name[ro]=Monteaza imagine
Name[ru]=Смонтировать образ
Name[sk]=PripojiÃÂ¥ obraz'

MENU_UNMOUNT='[Desktop Action UnmountISOImage]
Icon=cdimage
Name=Unmount Image
Name[br]=Desmontar a imagem
Name[cs]=Odpojit obraz
Name[da]=AfmontУЉr CD-billede
Name[de]=ISO-File Einbindung l�en
Name[es]=Desmontar imagen
Name[fr]=DÑmonter l`image
Name[hu]=LemezkÃÂÃÂ©p levÃÂÃÂ¡lasztÃÂÃÂ¡sa
Name[it]=Smonta immagine
Name[pl]=Odmontuj obraz
Name[pt_BR]=Desmontar a imagem
Name[ro]=Demonteaza imagine
Name[ru]=Отмонтировать образ
Name[sk]=OdpojiÃÂ¥ obraz'

MENU_CREATEISO='[Desktop Action CreateISOImage]
Icon=cdimage
Name=Create ISO Image
Name[de]=ISO-Image erstellen
Name[it]=Crea immagine ISO
Name[pl]=Utw�z obraz ISO
Name[ro]=Creat,i imagine ISO
Name[ru]=Создать ISO-образ'

MENU_GRABISO='[Desktop Action GrabISOImage]
Icon=cdimage
Name=Create ISO Image from CD-ROM
Name[it]=Crea immagine ISO dal CDROM
Name[ru]=Создать ISO-образ компакт-диска'

MENU_CALC='[Desktop Action CalcMD5Sum]
Icon=cdimage
Name=Calculate MD5 Sum
Name[it]=Calcola somma MD5
Name[ru]=Вычислить MD5 сумму'

MENU_CONV2ISO='[Desktop Action ConvertCONV2ISO]
Icon=cdimage
Name=Convert to ISO
Name[it]=Converti in ISO
Name[ru]=Конвертировать в образ ISO'

MENU_CHECK='[Desktop Action CheckISOType]
Icon=cdimage
Name=Check ISO Type
Name[ru]=Проверить тип ISO-образа'

DESKTOP_IMG='[Desktop Entry]
Type=MimeType
Patterns=*.img;*.IMG
MimeType=application/x-img
Icon=cdimage
Comment=NRG image file
Comment[az]=IMAGE əks faylı
Comment[be]=Файл вобразу IMAGE
Comment[bg]=Файл снимка IMAGE
Comment[bs]=IMAGE image datoteka
Comment[ca]=Fitxer d`imatge IMAGE
Comment[cs]=Soubor s IMAGE obrazem
Comment[cy]=Ffeil delwedd IMAGE
Comment[da]=IMAGE billedfil
Comment[de]=IMAGE-Bilddatei
Comment[el]=Αρχείο εικόνας IMAGE
Comment[es]=Archivo de imagen IMAGE
Comment[et]=IMAGE tõmmisefail
Comment[eu]=IMAGE irudia fitxategia
Comment[fa]=پرونده‌ی IMAGE
Comment[fi]=IMAGE binäärikuva
Comment[fr]=Image IMAGE
Comment[gl]=Ficheiro de imaxe IMAGE
Comment[he]=קובץ מראה של IMAGE
Comment[hi]=IMAGE चित्र फाइल
Comment[hu]=IMAGE-képmásfájl
Comment[it]=File immagine IMAGE
Comment[lt]=IMAGE atvaizdo byla
Comment[mn]=IMAGE хэв файл
Comment[nb]=IMAGE bildefil
Comment[nl]=IMAGE-beeldbestand
Comment[nn]=IMAGE-biletfil
Comment[pl]=Plik obrazu systemu plików IMAGE
Comment[pt]=Ficheiro com imagem IMAGE
Comment[pt_BR]=Imagem IMAGE
Comment[ro]=Fişier imagine IMAGE
Comment[ru]=Файл образа IMAGE
Comment[se]=IMAGE-govvafiila
Comment[sk]=Obraz disku IMAGE
Comment[sl]=Podoba plošče IMAGE
Comment[sr]=Фајл IMAGE одраза
Comment[sv]=IMAGE-avbildsfil
Comment[ta]=IMAGE உருக் கோப்பு
Comment[tg]=Файли тасвири IMAGE
Comment[tr]=IMAGE Dosyası
Comment[uk]=Файл образу IMAGE
Comment[uz]=IMAGE-тасвир файли
Comment[wa]=Fitchî imådje IMAGE
Comment[xx]=xxIMAGE image filexx
Comment[zh_CN]=IMAGE 映像文件
Comment[zh_TW]=IMAGE 映像檔'

# -------------------------------------------------------------------------
function check_env {
# parameters:
# - $1 = Description
# - $2 = Default location
# - $3 = Fallback
# -------------------------------------------------------------------------

  if ( test -d "$2" ) then
    DIR="$2"
  elif ( test -d "$3" ) then
    DIR="$3"
  else
    echo
    while ( test ! -d "$DIR" )
    do
      echo "Couldn't find $1!"
      echo -n "Type the full path here or press \"Ctrl+C\" to abort: "
      read DIR
    done
  fi
  DIR="`dirname "$DIR"`/`basename "$DIR"`"
  echo "* $1: $DIR"
  
}

# -------------------------------------------------------------------------
function check_bin {
# parameters:
# - $1 = Binary name
# - $2 = Default location
# -------------------------------------------------------------------------
  
  BIN=""
  WHICH="`type -path -all "$1" | head -1`"
  if ( test -f "$2" ) then
    BIN="$2"
    echo " [$1]: $BIN"
  elif ( test -f "$WHICH" ) then
    BIN="$WHICH"
    echo " [$1]: $BIN"
  else
    echo " [$1]: >> not found <<" 
  fi

}

# -------------------------------------------------------------------------
function check_dev {
# parameters:
# - $1 = Device name
# - $2 = Default location
# - $3 = Fallback
# -------------------------------------------------------------------------
  
  DEV=""
  if ( test -b "$2" ) then
    DEV="$2"
    echo "  + $1: $DEV"
  elif ( test -b "$3" ) then
    DEV="$3"
    echo "  + $1: $DEV"
  else
    echo "  - $1: >> not found <<" 
  fi

}

# -------------------------------------------------------------------------
function find_bin {
# parameters:
# - $1 = Binary name
# - $2 = Default location
# -------------------------------------------------------------------------

  echo
  BIN=""
  if ( test ! -z "$2" ) then
    echo "Type the full path to \"$1\""
    echo -n "or press \"Enter\" to continue [$2]: "
    read BIN
    test -z "$BIN" && BIN="$2"
  fi
  while ( test ! -f "$BIN" )
  do
    echo "Couldn't find \"$1\"!"
    echo -n "Type the full path here or \"C\" to cancel: "
    read BIN
    if ( test "$BIN" = "c" ) || ( test "$BIN" = "C" )  then
      BIN=""
      return 1
    fi
  done
  
}

# -------------------------------------------------------------------------
function find_dev {
# parameters:
# - $1 = Device name
# - $2 = Default location
# -------------------------------------------------------------------------

  echo
  DEV=""
  if ( test ! -z "$2" ) then
    echo "Type the full path to \"$1\""
    echo -n "or press \"Enter\" to continue [$2]: "
    read DEV
    test -z "$DEV" && DEV="$2"
  fi
  while ( test ! -b "$DEV" )
  do
    echo "Couldn't find \"$1\"!"
    echo -n "Type the full path here or \"C\" to cancel: "
    read DEV
    if ( test "$DEV" = "c" ) || ( test "$DEV" = "C" )  then
      DEV=""
      return 1
    fi
  done
  
}

# -------------------------------------------------------------------------
function set_env {
# parameters:
# none
# -------------------------------------------------------------------------

  if ( test "$UID" -ne "0" ) then
    check_env "KDE config folder" "$LOCAL" "$HOME/.kde"
  else
    check_env "KDE install prefix" "$SYSTEM" "/opt/kde3"
  fi
  PREFIX="$DIR"

  check_env "Desktop folder" "$DESKTOP" "$HOME/Desktop"
  DESKTOP='$HOME/'"${DIR#$HOME/}"

}

# -------------------------------------------------------------------------
function set_bin {
# parameters:
# none
# -------------------------------------------------------------------------

  echo -n "* Convert CUE/BIN to ISO"
  check_bin "bchunk" "$BCHUNK"
  BCHUNK="$BIN"
  echo -n "* Convert CloneCD to ISO"
  check_bin "ccd2iso" "$CCD2ISO"
  CCD2ISO="$BIN"
  echo -n "* Mount CUE/BIN"
  check_bin "cdemu" "$CDEMU"
  CDEMU="$BIN"
  echo -n "* Manage XBOX images"
  check_bin "extract-xiso" "$XISO"
  XISO="$BIN"
  
}

# -------------------------------------------------------------------------
function set_dev {
# parameters:
# none
# -------------------------------------------------------------------------

  echo "* CD drives"
  check_dev "CD-ROM" "$CDROM0" "/dev/cdrom"
  CDROM0="$DEV"
  echo "* CDEMU nodes"
  check_dev "Node0" "$CDEMU0" "/dev/cdemu/0"
  CDEMU0="$DEV"


}

# -------------------------------------------------------------------------
function hi {
# parameters:
# - $1 = selected install mode (kdesu or sudo)
# -------------------------------------------------------------------------
  
  clear
  echo
  echo "     - $FULLNAME v$VERSION (using \"$1\") -"
  echo

}

# -------------------------------------------------------------------------
function bye {
# parameters:
# none
# -------------------------------------------------------------------------
  
  echo
  echo "     - Thank you for using $FULLNAME! -"
  echo

}

# -------------------------------------------------------------------------
function byebye {
# parameters:
# none
# -------------------------------------------------------------------------
  
  clear
  echo
  echo "         - Uninstalling $FULLNAME -"
  echo

}

# -------------------------------------------------------------------------
function install_kde {
# parameters:
# - $1 = selected install mode (sudo or kdesu)
# -------------------------------------------------------------------------
  
  hi $1
  install_menu
  install_mime
  install_script $1 kde
  bye

}

# -------------------------------------------------------------------------
#function install-?? {
# parameters:
# - $1 = selected install mode (?? or ??)
# -------------------------------------------------------------------------
#
#  hi $1
#  install_script $1 ??
#  bye
#
#}

# -------------------------------------------------------------------------
function uninstall {
# parameters:
# none
# -------------------------------------------------------------------------
  
  SH="$PREFIX/share/apps/$NAME/"
  NRG="$PREFIX/share/mimelnk/application/x-nrg.desktop"
  CCD="$PREFIX/share/mimelnk/application/x-ccd.desktop"
  CUE="$PREFIX/share/mimelnk/application/x-cue.desktop"
  DSK1="$PREFIX/share/apps/konqueror/servicemenus/$NAME.desktop"
  DSK2="$PREFIX/share/apps/konqueror/servicemenus/$NAME-dir.desktop"
  DSK3="$PREFIX/share/apps/konqueror/servicemenus/$NAME-cue.desktop"
  DSK4="$PREFIX/share/apps/konqueror/servicemenus/$NAME-ccd.desktop"
  DSK5="$PREFIX/share/apps/konqueror/servicemenus/$NAME-grb.desktop"
  DSK6="$PREFIX/share/apps/konqueror/servicemenus/$NAME-nrg.desktop"
  DSK7="$PREFIX/share/apps/konqueror/servicemenus/$NAME-emu.desktop"
  DSK8="$PREFIX/share/apps/konqueror/servicemenus/$NAME-xbx.desktop"

  echo -n "Removing $NAME.sh:               "
  if ( test -d "$SH" )
  then
    rm -r "$SH" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing $NAME.desktop:          "
  if ( test -f "$DSK1" )
  then
    rm "$DSK1" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing $NAME-dir.desktop:      "
  if ( test -f "$DSK2" )
  then
    rm "$DSK2" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing $NAME-cue.desktop:      "
  if ( test -f "$DSK3" )
  then
    rm "$DSK3" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing $NAME-ccd.desktop:      "
  if ( test -f "$DSK4" )
  then
    rm "$DSK4" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing $NAME-grb.desktop:      "
  if ( test -f "$DSK5" )
  then
    rm "$DSK5" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing $NAME-nrg.desktop:      "
  if ( test -f "$DSK6" )
  then
    rm "$DSK6" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing $NAME-emu.desktop:      "
  if ( test -f "$DSK7" )
  then
    rm "$DSK7" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing $NAME-xbx.desktop:      "
  if ( test -f "$DSK8" )
  then
    rm "$DSK8" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing x-nrg.desktop:             "
  if ( test -f "$NRG" )
  then
    rm "$NRG" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing x-ccd.desktop:             "
  if ( test -f "$CCD" )
  then
    rm "$CCD" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  echo -n "Removing x-cue.desktop:             "
  if ( test -f "$CUE" )
  then
    rm "$CUE" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ NONE ]"
  fi
  
}

# -------------------------------------------------------------------------
function install_menu {
# parameters:
# none
# -------------------------------------------------------------------------
  
  echo -n "Creating a folder for servicemenus: "
  if ( test ! -d "$PREFIX/share/apps/konqueror/servicemenus/" )
  then
    mkdir -p "$PREFIX/share/apps/konqueror/servicemenus/" 2>/dev/null
    test -d "$PREFIX/share/apps/konqueror/servicemenus" &&
    echo "[  OK  ]" || { echo "[FAILED]" ; exit 1; }
  else
    echo "[ SKIP ]"
  fi

  echo -n "Installing $NAME.desktop:        "

  echo -n '[Desktop Entry]
Actions=MountISOImage;UnmountISOImage;CalcMD5Sum;CheckISOType;
Encoding=UTF-8
ServiceTypes=application/x-iso,inode/ISO-image
'"$MENU_HEAD"'

'"$MENU_MOUNT"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" mount

'"$MENU_UNMOUNT"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" unmount

'"$MENU_CALC"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" calc

'"$MENU_CHECK"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" checkiso
' > "$PREFIX/share/apps/konqueror/servicemenus/$NAME.desktop" &&
  echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }

  echo -n "Installing $NAME-dir.desktop:    "

  echo '[Desktop Entry]
Actions=CreateISOImage;CreateUDFImage;
Encoding=UTF-8
ServiceTypes=inode/directory
'"$MENU_HEAD"'

'"$MENU_CREATEISO"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" createiso

'"$(echo "$MENU_CREATEISO" | sed "s/ISO/UDF/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" createudf
' > "$PREFIX/share/apps/konqueror/servicemenus/$NAME-dir.desktop" &&
  echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }

  echo -n "Installing $NAME-cue.desktop:    "
  if ( test ! -z "$BCHUNK" ) then
    echo '[Desktop Entry]
Actions=ConvertCUE/BIN2ISO;
Encoding=UTF-8
ServiceTypes=application/x-cue
'"$(echo "$MENU_HEAD" | sed "s/ISO/CUE\/BIN/")"'

'"$(echo "$MENU_CONV2ISO" | sed "s/CONV/CUE\/BIN/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" bin2iso
' > "$PREFIX/share/apps/konqueror/servicemenus/$NAME-cue.desktop" &&
    echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ SKIP ]"
  fi
  
  echo -n "Installing $NAME-ccd.desktop:    "
  if ( test ! -z "$CCD2ISO" ) then
    echo '[Desktop Entry]
Actions=ConvertCloneCD2ISO;
Encoding=UTF-8
ServiceTypes=application/x-ccd
'"$MENU_HEAD"'

'"$(echo "$MENU_CONV2ISO" | sed "s/CONV/CloneCD/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" ccd2iso
' > "$PREFIX/share/apps/konqueror/servicemenus/$NAME-ccd.desktop" &&
    echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ SKIP ]"
  fi

  echo -n "Installing $NAME-grb.desktop:    "
  if ( test ! -z "$CDROM0" ) then
    echo '[Desktop Entry]
Actions=GrabISOImage;
Encoding=UTF-8
ServiceTypes=inode/directory
'"$MENU_HEAD"'

'"$MENU_GRABISO"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" grabiso
' > "$PREFIX/share/apps/konqueror/servicemenus/$NAME-grb.desktop" &&
    echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ SKIP ]"
  fi
  
  echo -n "Installing $NAME-nrg.desktop:    "

  echo '[Desktop Entry]
Actions=MountNRGImage;UnmountNRGImage;CalcMD5Sum;ConvertNRG2ISO;
Encoding=UTF-8
ServiceTypes=application/x-nrg
'"$(echo "$MENU_HEAD" | sed "s/ISO/NRG/")"'

'"$(echo "$MENU_MOUNT" | sed "s/ISO/NRG/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" mount

'"$(echo "$MENU_UNMOUNT" | sed "s/ISO/NRG/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" unmount

'"$MENU_CALC"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" calc

'"$(echo "$MENU_CONV2ISO" | sed "s/CONV/NRG/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" nrg2iso
' > "$PREFIX/share/apps/konqueror/servicemenus/$NAME-nrg.desktop" &&
  echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }

  echo -n "Installing $NAME-emu.desktop:    "
  if ( test ! -z "$CDEMU" ) then
    echo '[Desktop Entry]
Actions=MountCUE/BINImage;UnmountCUE/BINImage;
Encoding=UTF-8
ServiceTypes=application/x-cue
'"$(echo "$MENU_HEAD" | sed "s/ISO/CUE\/BIN/")"'

'"$(echo "$MENU_MOUNT" | sed "s/ISO/CUE\/BIN/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" mountcb

'"$(echo "$MENU_UNMOUNT" | sed "s/ISO/CUE\/BIN/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" unmount
' > "$PREFIX/share/apps/konqueror/servicemenus/$NAME-emu.desktop" &&
    echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ SKIP ]"
  fi 

  echo -n "Installing $NAME-xbx.desktop:    "
  if ( test ! -z "$XISO" ) then
    echo '[Desktop Entry]
Actions=CreateXDVDFSImage;
Encoding=UTF-8
ServiceTypes=inode/directory
'"$MENU_HEAD"'

'"$(echo "$MENU_CREATEISO" | sed "s/ISO/XDVDFS/")"'
Exec='$PREFIX'/share/apps/'$NAME'/'$NAME'.sh "%U" createxbx
' > "$PREFIX/share/apps/konqueror/servicemenus/$NAME-xbx.desktop" &&
    echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ SKIP ]"
  fi 
  
}

# -------------------------------------------------------------------------
function install_script {
# parameters:
# - $1 = selected install mode (kdesu, sudo or ?)
# - $2 = Desktop environment (kde or ?)
# -------------------------------------------------------------------------
  
  
  case $1 in
    sudo)
      MOUNT='sudo mount -t udf,iso9660 -o loop,ro,nodev,noexec,nosuid${MODE} "${1}" "$MOUNTDIR"'
      UNMOUNT='sudo umount "$MOUNTDIR"'
      ;;
    kdesu)
      MOUNT='kdesu -c "mount -t udf,iso9660 -o loop,ro,nodev,noexec,nosuid${MODE} \"${1}\"  \"$MOUNTDIR\""'
      UNMOUNT='kdesu -c "umount \"$MOUNTDIR\""'
      ;;
    *)
      echo 'Not implemented yet!'
      exit 1
      ;;
  esac
  
  case $2 in
    kde)
      DIALOG='kdialog'
      ;;
    *)
      echo 'Not implemented yet!'
      exit 1
      ;;
  esac
  
  echo -n "Installing $NAME.sh:             "
  if ( test -d "$PREFIX/share/apps/$NAME/" )
  then
    rm -r "$PREFIX/share/apps/$NAME"
  fi
  
  mkdir -p "$PREFIX/share/apps/$NAME" 2>/dev/null
  test -d "$PREFIX/share/apps/$NAME" &&
  echo '#!/bin/sh
# '$FULLNAME' v'$VERSION'
BSNAME="`basename "$1"`"

if ( `echo "$BSNAME" | grep "Mount-ISO" > /dev/null` ) then
  MOUNTDIR="$1"
else
  MOUNTDIR="'$DESKTOP'/Mount-ISO ($BSNAME)"
fi

function dialog {
  '$DIALOG' --title "'$FULLNAME'" --msgbox "$1"
}

function err {
  case "$1" in
   1)
     ERROR_MESSAGE="\"$2\" is not readable, check file permissions!"
     ;;
   2)
     ERROR_MESSAGE="\"$2\" is already mounted!"
     ;;
   3)
     ERROR_MESSAGE="\"$2\" could not be created!"
     ;;
   4)
     ERROR_MESSAGE="\"$2\" is not mounted!"
     ;;
   5)
     ERROR_MESSAGE="Folder \"$2\" exists but \"$3\" is not mounted!"
     ;;
   6)
     ERROR_MESSAGE="Could not mount \"$2\"! Check your system settings."
     ;;
   7)
     ERROR_MESSAGE="\"$2\" has data error! File might be of wrong type or corrupted."
     ;;
   8)
     ERROR_MESSAGE="\"$2\" is not a directory!"
     ;;
   9)
     ERROR_MESSAGE="Error creating ISO image from directory \"$2\"!"
     ;;
   10)
     ERROR_MESSAGE="\"$2\" is a directory - MD5 sum can not be calculated!"
     ;;
   11)
     ERROR_MESSAGE="\"$2\" file does not exist!"
     ;;
   12)
     ERROR_MESSAGE="ISO creation failed! Check if you have CD in your CDROM and if you have required permissions."
     ;;
   13)
     ERROR_MESSAGE="Unmounting \"$2\" failed! Check if some programs are using it, close them and try again."
     ;;
   *)
     return 0
     ;;
  esac
  dialog "ERROR: $ERROR_MESSAGE"
  exit 0
}

function msg {
  case "$1" in
    1)
      INFO_MESSAGE="ISO image \"$2\" successfully created in \"$3\"!"
      ;;
    2)
      INFO_MESSAGE="MD5 checksum of \"$2\" is: \"$3\""
      ;;
    3)
      INFO_MESSAGE="Tracks were saved as \"$2XX.iso\" in \"$3\""
      ;;
    4)
      INFO_MESSAGE="UDF image \"$2\" successfully created in \"$3\"!"
      ;;
    5)
      INFO_MESSAGE="CloneCD image was converted into \"$2\" and saved in \"$3\""
      ;;
    6)
      INFO_MESSAGE="Image file \"$2\" is of type \"$3\""
      ;;
    *)
      return 0
      ;;
  esac
  dialog "$INFO_MESSAGE"
  exit 0
}

function check_mount {
  DEV="`mount | grep "$1" | cut -f 1 -d " "`"
  if ( test ! -z "$DEV" ) then
    return 0
  else
    return 1
  fi
}

function check_cdemu {
  if ( `'$CDEMU' -s | grep "$1" > /dev/null` ) then
    return 0
  else
    return 1
  fi
}

function check_iso {
  TYPE=`head "$1" | od -Ax -s | head -n 1 | cut -f 1 -d " " `
    case "$TYPE" in
      008008)
        # ISO image
        CHECK="Standard ISO9660 image"
        ;;
      008028)
        # ISO image (by WinISO)
        CHECK="Standard ISO9660 image (by WinISO)"
        ;;
      053008)
        # NRG image
        CHECK="NRG image (by Nero)"
        ;;
      007a69)
        # XDVDFS image
        CHECK="XBOX DVD image"
        ;;  
      *)
        # Anything else
        CHECK="Unknown format"
        ;;
    esac
}

case "$2" in
  mount)
    if (test -d "$MOUNTDIR") then
      check_mount "$MOUNTDIR" &&
      err 2 "$1"
    else
      test -r "$1" ||
      err 1 "$1"
      mkdir -p "$MOUNTDIR"
    fi
    if ( test -d "$MOUNTDIR" )
    then
      TYPE=`head "$1" | od -Ax -s | head -n 1 | cut -f 1 -d " " `
      case "$TYPE" in
        008008)
          # ISO image
          MODE=",defaults"
          ;;
        008028)
          # ISO image (by WinISO)
          MODE=",defaults"
          ;;
        053008)
          # NRG image
          MODE=",offset=307200"
          ;;
        007a69)
          # XDVDFS image
          rmdir "$MOUNTDIR"
          err 7 "$1"
          ;;  
        *)
          # Anything else
          rmdir "$MOUNTDIR"
          err 7 "$1"
          ;;
      esac
      '$MOUNT'
    fi
    if ( check_mount "$MOUNTDIR" ) then
      kfmclient openURL "$MOUNTDIR"
    else
      rmdir "$MOUNTDIR"
      err 6 "$MOUNTDIR"
    fi
    ;;
  unmount)
    if (test ! -d "$MOUNTDIR") then
      err 4 "$1"
    elif (check_mount "$MOUNTDIR") then
      '$UNMOUNT' &&
      rmdir "$MOUNTDIR" ||
      err 13 "$1"
      if ( test "${DEV##/dev/cdemu/}" -ge 0 2>/dev/null ) then
        '$CDEMU' -u ${DEV##/dev/cdemu/}
      fi
    else
      err 5 "$MOUNTDIR" "$1"
    fi
    ;;
  createiso)
    ISOFILE="`basename "$1"`.iso"
    SAVEDIR="`dirname "$1"`"
    
    if ( test ! -w "$SAVEDIR" ) then
      SAVEDIR="'$DESKTOP'"
    fi
    
    if ( test ! -d "$1" ) then
      err 8 "$1"
    fi
   
    mkisofs -joliet -rock -quiet -no-bak -o "$SAVEDIR/$ISOFILE" "$1" &&
    msg 1 "$ISOFILE" "$SAVEDIR" ||
    err 9 "$1"
    ;;
  createudf)
    ISOFILE="`basename "$1"`.iso"
    SAVEDIR="`dirname "$1"`"
    
    if ( test ! -w "$SAVEDIR" ) then
      SAVEDIR="'$DESKTOP'"
    fi
    
    if ( test ! -d "$1" ) then
      err 8 "$1"
    fi
   
    mkisofs -dvd -quiet -no-bak -o "$SAVEDIR/$ISOFILE" "$1" &&
    msg 4 "$ISOFILE" "$SAVEDIR" ||
    err 9 "$1"
    ;;
  calc)
    if ( test -d "$1" ) then
      err 10 "$1"
    elif ( test -f "$1" ) then
      SUM=`md5sum "$1" | cut -f 1 -d " "`
      msg 2 "$BSNAME" "$SUM"
    fi
    ;;
  bin2iso)
    SAVEDIR="`dirname "$1"`"
    BASE="${BSNAME%.*}"
    BINFILE="$SAVEDIR/"`head -n 1 "$1" | cut -f 2 -d " " | sed -e "s/^\"//" -e "s/\"$//"`
    
    if ( test ! -w "$SAVEDIR" ) then
      SAVEDIR="'$DESKTOP'"
    fi
    
    if ( test ! -f "$BINFILE" ) then
      err 11 "`basename "$BINFILE"`"
    else
      '$BCHUNK' "$BINFILE" "$1" "$BASE" > /dev/null
      ls -1b "${BASE}"*.iso | while read file; do mv "$file" $SAVEDIR; done
      msg 3 "$BASE" "$SAVEDIR"
    fi
    ;;
  ccd2iso)
    SAVEDIR="`dirname "$1"`"
    BASE="${BSNAME%.*}"
    IMGFILE="$SAVEDIR/$BASE.img"
    
    if ( test ! -w "$SAVEDIR" ) then
      SAVEDIR="'$DESKTOP'"
    fi
    
    if ( test ! -f "$IMGFILE" ) then
      err 11 "$BASE.img"
    else
      '$CCD2ISO' "$IMGFILE" "$SAVEDIR/$BASE.iso" > /dev/null
      msg 5 "$BASE.iso" "$SAVEDIR"
    fi
    ;;
  grabiso)
    if ( test ! -w "$1" ) then
      IMGFILE="`kdialog --inputbox "This directory is read-only, saving to Desktop! Choose name for ISO-image:" "'$DESKTOP'/mount.iso"`" || exit 0
    else
      IMGFILE="`kdialog --inputbox "Choose name for ISO-image:" "$1/mount.iso"`" || exit 0
    fi
    SAVEDIR="`dirname "$IMGFILE"`"
                 
    while ( ( test ! -w "$SAVEDIR" ) || ( test -f "$IMGFILE" ) )
    do
      if ( test -f "$IMGFILE" ) then
        IMGFILE="`kdialog --inputbox "File with this name already exists! Choose another name:" "$IMGFILE"`" ||
        exit 0
      elif ( test ! -w "$SAVEDIR" ) then
        IMGFILE="`kdialog --inputbox "Permission to write here is denied! Choose another name:" "$IMGFILE"`" ||
        exit 0
      fi
      SAVEDIR="`dirname "$IMGFILE"`"
        
    done
    
    if ( test "$SAVEDIR" != "$IMGFILE" ) then
      dd if="'$CDROM0'" of="$IMGFILE" &&
      msg 1 "`basename "$IMGFILE"`" "$SAVEDIR" ||
      err 
    fi
    ;;
  nrg2iso)
    SAVEDIR="`dirname "$1"`"
    BASE="${BSNAME%.*}"
    IMGFILE="$SAVEDIR/$BASE.iso"
    
    if ( test ! -w "$SAVEDIR" ) then
      SAVEDIR="'$DESKTOP'"
    fi
    
    TYPE=`head "$1" | od -Ax -s | head -n 1 | cut -f 1 -d " " `
    case "$TYPE" in
      053008)
        dd if="$1" of="$IMGFILE" bs=512 skip=600 > /dev/null &&
        msg 5 "$BASE.iso" "$SAVEDIR" || 
        err 3 "$IMGFILE"
        ;;
      *)
        err 7 "$1"
        ;;
    esac
    ;;
  mountcb)
    BASE="${BSNAME%.*}"
    BINFILE="$SAVEDIR/"`head -n 1 "$1" | cut -f 2 -d " " | sed -e "s/^\"//" -e "s/\"$//"`
    NODE=$((`'$CDEMU' -s | cut -f 8 -d " " | grep 0 -n -m 1 | cut -c 1`-2))
        
    if (test -d "$MOUNTDIR") then
      check_mount "$MOUNTDIR" &&
      err 2 "$1"
    else
      mkdir -p "$MOUNTDIR"
    fi
    if ( test -d "$MOUNTDIR" )
    then
      '$CDEMU' $NODE "$1" &&
      mount /dev/cdemu/$DEV "$MOUNTDIR" ||
      '$CDEMU' -u $NODE
    fi
    if ( check_mount "$MOUNTDIR" ) then
      kfmclient openURL "$MOUNTDIR"
    else
      rmdir "$MOUNTDIR"
      err 6 "$MOUNTDIR"
    fi
    ;;
  xbx2iso)
    SAVEDIR="`dirname "$1"`"
    BASE="${BSNAME%.*}"
    IMGFILE="$SAVEDIR/$BASE.img"
    
    if ( test ! -w "$SAVEDIR" ) then
      SAVEDIR="'$DESKTOP'"
    fi
    
    if ( test ! -f "$IMGFILE" ) then
      err 11 "$BASE.img"
    else
      '$CCD2ISO' "$IMGFILE" "$SAVEDIR/$BASE.iso" > /dev/null
      msg 5 "$BASE.iso" "$SAVEDIR"
    fi
    ;;
  createxbx)
    ISOFILE="`basename "$1"`.iso"
    SAVEDIR="`dirname "$1"`"
    
    if ( test ! -w "$SAVEDIR" ) then
      SAVEDIR="'$DESKTOP'"
    fi
    
    if ( test ! -d "$1" ) then
      err 8 "$1"
    fi
   
    '$XISO' -c "$1" "$SAVEDIR/$ISOFILE"  &&
    msg 4 "$ISOFILE" "$SAVEDIR" ||
    err 9 "$1"
    ;;
  checkiso)
    check_iso "$1"
    msg 6 "$BSNAME" "$CHECK"
    ;;
esac
' > "$PREFIX/share/apps/$NAME/$NAME.sh" &&
  chmod +x "$PREFIX/share/apps/$NAME/$NAME.sh" && echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }

}

# -------------------------------------------------------------------------
function install_mime {
# parameters:
# none
# -------------------------------------------------------------------------
  echo -n "Creating a folder for associations: "
  if ( test ! -d "$PREFIX/share/mimelnk/application" )
  then
    mkdir -p "$PREFIX/share/mimelnk/application/" 2>/dev/null
    test -d "$PREFIX/share/mimelnk/application" &&
    echo "[  OK  ]" || { echo "[FAILED]" ; exit 1; }
  else
    echo "[ SKIP ]"
  fi
  
  echo -n "Installing associations (*.NRG):    "
  
  echo "$DESKTOP_IMG" | sed "s/IMG/NRG/g" | sed "s/img/nrg/g" | sed "s/IMAGE/NRG/g" > \
    "$PREFIX/share/mimelnk/application/x-nrg.desktop" &&
  echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }

  echo -n "Installing associations (*.CCD):    "
  
  if ( test ! -z "$CCD2ISO" ) then
    
    echo "$DESKTOP_IMG" | sed "s/IMG/CCD/g" | sed "s/img/ccd/g" | sed "s/IMAGE/CloneCD/g" > \
      "$PREFIX/share/mimelnk/application/x-ccd.desktop" &&
    echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ SKIP ]"
  fi

  echo -n "Installing associations (*.CUE):    "
  
  if ( test ! -z "$CDEMU" ) || ( test ! -z "$BCHUNK" ) then
    
    echo '[Desktop Entry]
Type=MimeType
Patterns=*.cue;*.CUE
MimeType=application/x-cue
Icon=cdimage
Comment=CUE file
Comment[ru]=CUE-файл
' > "$PREFIX/share/mimelnk/application/x-cue.desktop" &&
    echo "[  OK  ]" || { echo "[FAILED]"; exit 1; }
  else
    echo "[ SKIP ]"
  fi

  
}

# -------------------------------------------------------------------------
function setup_sudo {
# parameters:
# none
# -------------------------------------------------------------------------
  
  echo
  echo "Only root can edit sudo config - type root password here"
# add 1 line to /etc/sudoers to give users permission to (u)mount loopback devices in their home directory
  su -c 'echo; echo "Making a backup copy of /etc/sudoers in /etc/sudoers.$(date +%Y-%m-%d-%T)"; cp /etc/sudoers /etc/sudoers.$(date +%Y-%m-%d-%T) && echo "%users ALL=NOPASSWD:/bin/mount -t udf\,iso9660 -o loop\,ro\,nodev\,noexec\,nosuid\,* */Mount-ISO*,/bin/umount */Mount-ISO*" >> /etc/sudoers && echo && echo "Success! Press Enter to continue" && read'

}

# -------------------------------------------------------------------------
function reset_sudo {
# parameters:
# none
# -------------------------------------------------------------------------
  
  echo
  echo "Only root can edit sudo config - type root password here"
# copy the content of /etc/sudoers to a buffer first and then
# delete all lines in /etc/sudoers to give users permission to
# (u)mount loopback devices in their home directory
  su -c 'echo; echo "Making a backup copy of /etc/sudoers in /etc/sudoers.$(date +%Y-%m-%d-%T)"; cp /etc/sudoers /etc/sudoers.$(date +%Y-%m-%d-%T) && SUDOERS=$(</etc/sudoers) && echo "$SUDOERS" | sed -e "/[mM]ount-[iI][sS][oO]/d" > /etc/sudoers && echo && echo "Success! Press Enter to continue" && read'

}

# -------------------------------------------------------------------------
#
# MAIN
#
# -------------------------------------------------------------------------

# clear the screen
clear

# show main menu
while :
do
# clear the screen
  clear  
  # initialize and detect environment variables
  echo "             - $FULLNAME v$VERSION -"
  echo "--------------------------------------------"
  echo "Environment:"
  set_env
  echo "Devices:"
  set_dev
  echo "Utilities:"
  set_bin
  echo "--------------------------------------------"
  echo "Select action:"
  echo " 1 - Install $FULLNAME using $SUDO"
  echo " 2 - Install $FULLNAME using $SU"
  echo " 3 - Specify CDROM device name"
  echo " 4 - Specify utilities' locations"
  echo " 5 - Setup sudo config [*]"
  echo " 6 - Reset sudo config [*]"
  echo " 7 - Uninstall $FULLNAME"
  echo " 0 - Quit the installer"
  echo "--------------------------------------------"
  echo "[*] - requires root privileges"
  echo "--------------------------------------------"
  echo -n "Select options 1-7 or 0 to quit: "
  read line
# act accordingly
  case "$line" in
    1)
      install_$DE $SUDO
      exit 0
      ;;
    2) 
      install_$DE $SU
      exit 0
      ;;
    3)
      find_dev "CD-ROM" "$CDROM0"
      CDROM0="$DEV"
      find_dev "CDEMU" "$CDEMU0"
      CDEMU0="$DEV"
      continue
      ;;
    4)
      find_bin "bchunk" "$BCHUNK"
      BCHUNK="$BIN"
      find_bin "ccd2iso" "$CCD2ISO"
      CCD2ISO="$BIN"
      find_bin "cdemu" "$CDEMU"
      CDEMU="$BIN"
      find_bin "extract-xiso" "$XISO"
      XISO="$BIN"
      continue
      ;;
    5)
      setup_sudo
      continue
      ;;
    6)
      reset_sudo
      continue
      ;;
    7)
      byebye
      uninstall
      bye
      exit 0
      ;;
    0)
      bye
      exit 0
      ;;
    *)
      echo
      ;;
  esac
  
done
